# Autogenerated wrapper script for libftd2xx_jll for x86_64-apple-darwin14
export libftd2xx

## Global variables
PATH = ""
LIBPATH = ""
LIBPATH_env = "DYLD_FALLBACK_LIBRARY_PATH"

# Relative path to `libftd2xx`
const libftd2xx_splitpath = ["lib", "libftd2xx.1.4.16.dylib"]

# This will be filled out by __init__() for all products, as it must be done at runtime
libftd2xx_path = ""

# libftd2xx-specific global declaration
# This will be filled out by __init__()
libftd2xx_handle = C_NULL

# This must be `const` so that we can use it with `ccall()`
const libftd2xx = "@rpath/libftd2xx.dylib"


"""
Open all libraries
"""
function __init__()
    global artifact_dir = abspath(artifact"libftd2xx")

    # Initialize PATH and LIBPATH environment variable listings
    global PATH_list, LIBPATH_list
    # We first need to add to LIBPATH_list the libraries provided by Julia
    append!(LIBPATH_list, [joinpath(Sys.BINDIR, Base.LIBDIR, "julia"), joinpath(Sys.BINDIR, Base.LIBDIR)])
    global libftd2xx_path = normpath(joinpath(artifact_dir, libftd2xx_splitpath...))

    # Manually `dlopen()` this right now so that future invocations
    # of `ccall` with its `SONAME` will find this path immediately.
    global libftd2xx_handle = dlopen(libftd2xx_path)
    push!(LIBPATH_list, dirname(libftd2xx_path))

    # Filter out duplicate and empty entries in our PATH and LIBPATH entries
    filter!(!isempty, unique!(PATH_list))
    filter!(!isempty, unique!(LIBPATH_list))
    global PATH = join(PATH_list, ':')
    global LIBPATH = join(LIBPATH_list, ':')

    # Add each element of LIBPATH to our DL_LOAD_PATH (necessary on platforms
    # that don't honor our "already opened" trick)
    #for lp in LIBPATH_list
    #    push!(DL_LOAD_PATH, lp)
    #end
end  # __init__()

